var flyscanner = (function () {
    var flyscannerPublic = {};
    //---------------------------
    // FlyScan ™ 
    // (c)2015 Atlantide Design
    // All rights reserved
    // **************************
    // www.atlantide-design.it
    // **************************
    // code Alessandro Di Michele
    // idea Marco Di Gennaro
    //---------------------------

    //----------------
    //PREFERENZE UTENTE
    //vars passate di base
    var genitore;

    var fileName = "DJI_0001"; //per video, srt e jpg di base in cartellaInput
    var fileType = "mov"; //tipo filmato
    var cartellaInput = 'input'; //cartella input

    var cartellaOutput = 'output'; //cartella output


    var fineSrt = 0; //0 = primo
    var inizioSrt = 0; //0 = primo
    var rateSrt = 1; //1 = ogni 1

    var outFilePrefix = "grab"; //nome file di output del tipo  outFilePrefix-progressivo-time.jpg
    var outFile_mettiTime = false; //se mettere -time in nome file di output
    var outFile_numeroEsteso = false; // se formatta -n con 0 davanti
    var mostraHelp = false; //se help

    var cancellaGrab = false; //se cancellare cartella temp grab

    //---------------------------
    //SETTAGGI APP 
    //sys vars
    var APP_NAME = "FlyScan";
    var APP_VERSION = "v1.1a";
    var APP_COPYRIGHT = "(C)2016 Atlantide Design";
    var APP_SITE = "www.flyscan.it";

    var nomeFrami = "FRAMES"; //nome delle cose che salviamo
    var tempoBreve = true; //meglio true

    var cartellaTemp = "flyscan_temp";

    var cancellaOut = false; //sempre false

    //---------------------------
    //NON TOCCARE ALTRO

    //INCLUDE
    var piexif = require("./flyScan_libs/piexif/piexif.js");
    var parser = require("./flyScan_libs/subtitles-parser/subtitles.parser.min.js");
    var imagesize = require("./flyScan_libs/image-size");
    var fs = require("fs");
    var path = require('path');
    //inoltre necessita dell' eseguibile ffmpeg nel PATH di sistema

    //VARIABILI DELL'APP
    var contaSS =0;    
    var contaTEMPO= '0'; 
    var fatti = 0;
    var grabbi = [];
    var outti = [];
    var datti = [];
    var primopasso = true;
    
    var daFarne = 0;
    var daIniziare = 0;
    var daFinire = 0;
    var pixelXDim = 4096;
    var pixelYDim = 2160;

    var srtdata; //srt
    var cartellaGrab = cartellaOutput; //cartella di lavoro grabs
    var exifCampione;

    //calcolate una tantum
    var pathDiBase = __dirname.replace('flyScan','');
    cartellaOutput = path.join( pathDiBase , cartellaOutput ); //solo di default
    cartellaInput = path.join( pathDiBase , cartellaInput ); //solo di default
    cartellaGrab = path.join( pathDiBase , cartellaGrab, cartellaTemp ); //solo di default

    //calcolo path input
    var pathToFile = path.join(cartellaInput, fileName+'.'+fileType);
    var pathCampioneFile = path.join(cartellaInput, fileName+'.'+'jpg');
    var pathSrtFile = path.join(cartellaInput, fileName+'.'+'srt');

    //---------------------------

    //---------------------------
    //PROCEDURE PUBBLICHE   
    //INIT procedura 
    //fa SET (legge parametri) e poi GO
    flyscannerPublic.init = function(parametri) {
        //una tantum
        if (! flyscannerPublic.inizializzato) flyscannerPublic.inizializza;

        //go
        flyscannerPublic.set(parametri);
        flyscannerPublic.go();
    } 
    //---------------
    //INIZIALIZZA funzione 
    //fa controlli una tantum 
    flyscannerPublic.inizializza = function(parametri) {
        //se non trova ffmpeg da' errore
        flyscannerPublic.ffmpegPresente = true;
        flyscannerPublic.stopped = false;
        
        if ( String(localStorage.ffmpeg).length > 0 ) {
            //se c'e' qualcosa salvato
            try { 
                require('child_process').execSync((localStorage.ffmpeg + ' -h'), function (err) {
                    if ( String(err).length > 10 ) flyscannerPublic.ffmpegPresente = false;
                });
            } catch(errore)  {
                if ( String(errore).length > 10 ) flyscannerPublic.ffmpegPresente = false;
            }

            if (!flyscannerPublic.ffmpegPresente)  { 
                //presente
                flyscannerPublic.stopped = true;
                localStorage.ffmpeg = "";
            } 
        }
        else {
            //nulla salvato  
            //prima provo "ffmpeg" sun win
            var testpresente = true;
            var testurl = "/usr/local/bin/ffmpeg";
            if (process.platform.indexOf('win') != -1)  {
                //win
                testurl = "ffmpeg";
                try { 
                    require('child_process').execSync((testurl + ' -h'), function (err) {
                        if ( String(err).length > 10 ) testpresente = false;
                    });
                } catch(errore)  {
                    if ( String(errore).length > 10 ) testpresente = false;
                }
            } else {
                //mac
                testpresente = false;
            }
            
            if (!testpresente)  { 
                 //default fallito
                 flyscannerPublic.ffmpegPresente = false;
                 flyscannerPublic.stopped = true;
                 localStorage.ffmpeg = "";
            } 
            else {
                //default presente
                flyscannerPublic.ffmpegPresente = true;
                flyscannerPublic.stopped = false;
                localStorage.ffmpeg = testurl;
            }
        }
        
        //sempre
        flyscannerPublic.inizializzato= true;
        
        return flyscannerPublic.ffmpegPresente;
    }  
    //---------------
    //SET procedura 
    //legge paremetri 
    flyscannerPublic.set = function(parametri) {
        //una tantum
        if (! flyscannerPublic.inizializzato) flyscannerPublic.inizializza;

        //prendo preferenze
        if (parametri.g) { 
            genitore = parametri.g;
        }
        if(parametri.f){ 
            fileName = parametri.f; 
        }

        fineSrt = Number(parametri.e); 
        inizioSrt = Number(parametri.s); 
        rateSrt  = Number(parametri.r); 

        if(parametri.v){ 
            fileType = parametri.v; 
        }
        outFilePrefix = fileName;
        if(parametri.p){ 
            outFilePrefix = parametri.p; 
        }

        if(parametri.i){ 
            cartellaInput = parametri.i; 
        }
        if(parametri.o){ 
            cartellaOutput = parametri.o; 
            cartellaGrab = path.join(parametri.o, cartellaTemp); 
        }

        //resetto flags
        outFile_mettiTime = false;
        outFile_numeroEsteso = false;
        mostraHelp = false; 
        cancellaGrab = false;
        //flags
        if (parametri.t === "on") outFile_mettiTime = true; 
        if (parametri.n === "on") outFile_numeroEsteso = true; 
        if (parametri.h === "on" ) mostraHelp = true; 
        if (parametri.d === "on" ) cancellaGrab = true; 

        //ricalcolo path input in base a parametri
        pathToFile = path.join(cartellaInput, fileName+'.'+fileType);
        pathCampioneFile = path.join(cartellaInput, fileName+'.'+'jpg');
        pathSrtFile = path.join(cartellaInput, fileName+'.'+'srt');
    }    
    //---------------
    //GO procedura
    //fa CHECK, legge l'srt poi procede
    flyscannerPublic.go = function() { 
        //una tantum
        if (! flyscannerPublic.inizializzato) flyscannerPublic.inizializza;
        //resetto vars
        flyscannerPublic.stopped = false;
        contaSS = 0;    
        contaTEMPO = '0'; 
        fatti = 0;
        grabbi = [];
        outti = [];
        datti = [];
        srtdata = [];
        primopasso = true;
        
        //credits
        message(true);
        message( ' _______ __         _______                   ');                   
        message( '|    ___|  |.--.--.|     __|.----.---.-.-----.®');
        message( '|    ___|  ||  |  ||__     ||  __|  _  |     |');
        message( '|___|   |__||___  ||_______||____|___._|__|__|');
        message( '            |_____|                           ');
        message( ''+APP_NAME+' '+APP_VERSION+'     for DJI Inspire1');
        message( '');
        message( APP_COPYRIGHT+'        '+APP_SITE);
        message( '-----------------------------------------------');

        //verifico se esistono i 3 files video, srt e jpg
        var checkk = flyscannerPublic.check();
        var fileEsiste = ( (checkk[0] == true) && (checkk[1] == true) &&  (checkk[2] == true) );
        var fileErrore = "";
        if (!fileEsiste) fileErrore = checkk[3] + ' '+ checkk[4] + ' ' + checkk[5];

        //help
        if (mostraHelp) {
            message( '\parameters: ');
            message( '        ');
            message( '  f string  base filename for video, srt and jpg (default: DJI_0001)'); 
            message( '     (application looks for 3 files with that name and different ext.) '); 
            message( '  v string  extension of the video (default: mov)'); 
            message( '        ');
            message( '  s number  starts working from frame number (default: 0 = frame 1)'); 
            message( '  e number  ends working to frame number (default:0 = frame 1)'); 
            message( '  r number  frame rate, grabs every 1/n (default: 1)');         
            message( '        ');
            message( '  p string  prefix for the output file names (default: filename)'); 
            message( '     (output names will be like: prefix-n-timt.extension)');
            message( '  n         if present and "on", normalizes -n lenght');
            message( '  t         if present and "on", adds -time to the output file name'); 
            message( '        ');
            message( '  h         if present and "on", displays this help'); 
            message( '        ');
            message( '  i string  name of the input folder (default: input)'); 
            message( '  o string  name of the output folder (default: output)'); 
            message( '    (these names refer to folders in the application directory) '); 
            message( '        ');                    
            message( '--------');
            message( 'credits:\ncode: Alessandro Di Michele, idea: Marco Di Gennaro\n©2015 www.atlantide-design.it ');
            message( '--------');
        }

        if (fileEsiste)  {
            //ESEGUO ---
            //GEN
            if (fileType === "mov") tempoBreve = true; //di default per i mov
            //output
            message('1> FILENAME: '+fileName+ ' | VIDEOTYPE: '+fileType);
            message('1> OUTPUT: ' + cartellaOutput);
            if (!cancellaGrab) message('1> TEMP: ' + cartellaGrab +'');
            // / GEN

            //SRT
            flyscannerPublic.readSrt();
            message( '---');
            message('2> LOADED '+srtdata.length+' SRTs');
            message('2> COMPUTED START AT: '+ (inizioSrt+1) + ' | END AT: '+ (fineSrt+1) + ' | RATE: 1/' + rateSrt + ' | TO DO: ' + daFarne +' '+nomeFrami+'');
            // / SRT

            //PRENDO I DATI DAL CAMPIONE
            leggiDatiCampione();
            
            //LANCIO LA PROCEDURA ASINCRONA: GRAB
            faiGrab();
        } else {
            //NON ESEGUO ---
            message('1> FILENAME: '+fileName+ ' ERROR: '+fileErrore +'');
            message('2> NOT DONE !');    
        }
    }
    //---------------
    //STOP procedura
    flyscannerPublic.stop = function(faf) { 
       flyscannerPublic.stopped = true;
    }
    //---------------
    //CHECK utility
    //verifica la presenza dei files di input
    flyscannerPublic.check = function(){ 
            var fileEsiste1 = true;
            var fileErrore1 = "";
            var fileEsiste2 = true;
            var fileErrore2 = "";
            var fileEsiste3 = true;
            var fileErrore3 = "";
            if (!fs.existsSync(pathToFile)) { //MOV
               fileEsiste1 = false;
               fileErrore1 = "Missing ["+'.'+fileType+']';
            } else {
               fileErrore1 = pathToFile;
            }
            if (!fs.existsSync(pathCampioneFile)) { //JPG
               fileEsiste2 = false;
               fileErrore2 = "Missing ["+'.'+'jpg'+']';
            } else {
               fileErrore2 = pathCampioneFile;
            }
            if (!fs.existsSync(pathSrtFile)) { //SRT
               fileEsiste3 = false;
               fileErrore3 = "Missing ["+'.'+'srt'+']';
            } else {
               fileErrore3 = pathSrtFile;
            }
            var arresp = [fileEsiste1, fileEsiste2, fileEsiste3, fileErrore1, fileErrore2, fileErrore3];
            return arresp;
        }
    //---------------
    //SRT
    //read srt
    flyscannerPublic.readSrt = function(){ 
            //SRT
            var srt = fs.readFileSync(pathSrtFile,'utf8');
            srtdata = parser.fromSrt(srt, tempoBreve);
            var srtTotali = srtdata.length;
            daFinire = srtdata.length;
            if ( daFinire > fineSrt ) daFinire = fineSrt;
            daIniziare = inizioSrt;
            if ( daFinire < inizioSrt ) daIniziare = daFinire;
            daFarne = (daFinire-daIniziare+1);
            if (rateSrt > 1) { 
                daFarne = Math.floor(daFarne / rateSrt);
                if (daFarne < 1) daFarne = 1;
            }    
            // / SRT
    }
    //---------------
    //GETTERS
    //info
    flyscannerPublic.getName = function(){ 
           return APP_NAME;
        }
    flyscannerPublic.getVersion = function(){ 
           return APP_VERSION;
        }
    flyscannerPublic.getCopyright = function(){ 
           return APP_COPYRIGHT;
        }
    flyscannerPublic.getSite = function(){ 
           return APP_SITE;
        }
    flyscannerPublic.getSrtN = function(){ 
           flyscannerPublic.readSrt();
           return srtdata.length;
    }
    //---------------
    //VARS
    //flag verboso o meno
    flyscannerPublic.verbose = true;
    flyscannerPublic.stopped = false;
    //di servizio
    flyscannerPublic.inizializzato = false;
    flyscannerPublic.ffmpegPresente = true;

    //FINE PROCEDURE PUBBLICHE
    //----------------
    //FUNZIONI SRT
    //parsa il text srt di dji
    var parse_dji = function(stri) {
        //SRT, FORMATO A 3 RIGHE
        /*
        es.
        HOME(13.2037,42.0366) 2016.05.04 15:50:41
        GPS(13.2032,42.0362,15) BAROMETER:13.0
        ISO:100 Shutter:120 A:10 AA:10 EV: 0 Fnum:F2.8 
        */
        var parsed ={} ;
        var lungo = false;
        var righe = stri.split('\n');
        if (righe.length > 3) lungo = true;
        
        var  r1, r2, r3, r4, r5, r6, rpulito;
        r1 = righe[0].split(' ');
        r2 = righe[1].split(' ');

        if (lungo) {
            r4 = righe[2].split(' ');
            r5 = righe[3].split(' ');
            r6 = righe[4].split(' ');
            rpulito = righe[5].replace('EV: ', 'EV:');
            r3 = rpulito.split(' ');
        } else {
            rpulito = righe[2].replace('EV: ', 'EV:');
            r3 = rpulito.split(' ');
        }

        
        //RIGA 1 --------------
        parsed.home = r1[0];//
        var hll = ( parsed.home.substring(5, parsed.home.length-1 ) ).split(',');
        parsed.homeLat = hll[0];//
        parsed.homeLon = hll[1];//
        if (hll[2]) { parsed.homeHig = hll[2];}
        else {parsed.homeHig = 0;}
        parsed.date = r1[1]; //data
        parsed.time = r1[2]; //ora

        var darr=parsed.date.split('.');
        parsed.dateTime = darr[0] + ':' + ((darr[1].length<2)? '0':'') + darr[1] + ':' + ((darr[2].length<2)? '0':'') + darr[2] + ' ' + parsed.time;

        //RIGA 2 ---------------
        //GPS
        function ConvertDDToDMS(D){
            return {
                deg : 0|(D<0?D=-D:D),
                min : 0|D%1*60,
                sec :(0|D*60%1*6000)/100
            };
        }
        parsed.gps = r2[0];//
        var gll = ( parsed.gps.substring(4, parsed.gps.length-1 ) ).split(',');
        var gpsLat = [];
        var glaBase = gll[1];//
        var glabbo = ConvertDDToDMS(Number(glaBase));
        gpsLat.push ( [ glabbo.deg *10, 10 ] );
        gpsLat.push ( [ glabbo.min *10, 10 ] );
        gpsLat.push ( [ glabbo.sec *10, 10 ] );
        parsed.gpsLat = gpsLat; 

        var gpsLon = [];
        var gloBase = gll[0];//
        var globbo = ConvertDDToDMS(Number(gloBase));
        gpsLon.push ( [ globbo.deg *10, 10 ] );
        gpsLon.push ( [ globbo.min *10, 10 ] );
        gpsLon.push ( [ globbo.sec *10, 10 ] );
        parsed.gpsLon = gpsLon; 

        if (gll[2]) { parsed.gpsHig = gll[2]} 
        else { parsed.gpsHig = 0;}  //???
        parsed.gpsHig = gll[2];//???
        parsed.Hb = (r2[1].split(':'))[1]; //r2[1] Barometer
        if (r2[2]){ parsed.Hs = (r2[2].split(':'))[1] }
        else { parsed.Hs = parsed.Hb;} //r2[2]

        var altitudd = []; 
        var altiBase = parsed.Hb; //uso hb
        altitudd.push(altiBase*10000);
        altitudd.push(10000);
        parsed.altitude = altitudd; //mia

        //SE LUNGO
         if (lungo) {
            //RIGHE 3 4 5
            parsed.Vh = (r4[1].split(':'))[1]; //r3[1];
            parsed.Vv = (r4[2].split(':'))[1]; //r3[2];
            parsed.P = (r4[3].split(':'))[1]; //r3[3];
            parsed.R = (r4[4].split(':'))[1]; //r3[4];
            parsed.Y = (r4[5].split(':'))[1]; //r3[5];

            parsed.S1 = (r5[1].split(':'))[1]; //r4[1];
            parsed.S2 = (r5[2].split(':'))[1]; //r4[2];
            parsed.Err = (r5[3].split(':'))[1]; // r4[3];

            parsed.S = (r6[1].split(':'))[1]; //r5[1];
            parsed.V = (r6[2].split(':'))[1]; // r5[2];
            parsed.Rb = (r6[3].split(':'))[1]; //r5[3];
        }

        //RIGA ULTIMA (3 o 6) ---------------
        parsed.ISO = (r3[0].split(':'))[1];

        parsed.Shutter =[Number((r3[1].split(':'))[1]), 1000000];  //r3[1]; Shutter

        parsed.A = (r3[2].split(':'))[1];
        parsed.AA = (r3[3].split(':'))[1];
        
        var evBase = (r3[4].split(':'))[1];
        var evIn = evBase.split('/');
        var evOut = [];
        evOut.push( Number (evIn[0]) );
        if (evIn[1]) {evOut.push( Number (evIn[1]) );}
        parsed.EV = evOut; //r3[4];

        var tempir = (r3[5].split(':'))[1];//r3[5];
        var tempnum = Number( tempir.replace('F','') ) * 5 ;//[14,5]
        parsed.Fnum = [tempnum ,5] ; //r3[5];

        return parsed;
    }
    //---------------------------
    //PROCEDURE GRAB
    //GRAB procedura -> lancia PRE-EXIF
    //grabba i fotogrammi dal filmato in base ai tempi dell'srt
    var faiGrab = function() {
       //GRAB
        var pathToSnapshot;
        var pathToOutput;
        message('---');
        message('3> START PROCESSING...');

        var esisteGrab = fs.existsSync(cartellaGrab);
        if (esisteGrab) { 
            //se esiste cartellaGrab
            cancellaCartella(cartellaGrab, false); //svuoto files in grabs
        } else {
            //la crea
            fs.mkdirSync(cartellaGrab);
        }

        salvaGrab(); //lancio GRAB asincrono
        // / GRAB 
    }
    //----------------
    //FUNZIONI GRAB
    //esegue salva grab
    var salvaGrab = function() {
        //leggo i dati dell'srt attuale
        var qualeSrt = srtdata[daIniziare+( contaSS * rateSrt) ];
        contaTEMPO = qualeSrt.startTime ;
        if ( !tempoBreve ) contaTEMPO = contaTEMPO.replace(',','.')
        else contaTEMPO /= 1000;

        //genero nomi files
        var tempostr = "";
        if (outFile_mettiTime) tempostr = '-'+contaTEMPO;
        var stringaEnne = normalizza(contaSS+1, daFarne);
        var nomolo = ( outFilePrefix+'-' + stringaEnne + tempostr + '.jpg');
        pathToSnapshot = path.join( cartellaGrab, nomolo );
        pathToOutput = path.join( cartellaOutput, nomolo );

        //aggiungo nomi e dati srt agli array
        grabbi.push(pathToSnapshot);
        outti.push(pathToOutput);
        datti.push(qualeSrt);
        
        //procedo
        message("3>   ["+(contaSS+1)+"] grabbing: srt time = "+contaTEMPO+((tempoBreve )? "s":""  ) );
        //exe ffmpeg
        require('child_process').exec((localStorage.ffmpeg +' -ss '+ contaTEMPO +' -i "' + pathToFile + '" -vframes 1 -q:v 2 "' + pathToSnapshot+'"   '), function (err) {
            fineSalvaGrab(pathToSnapshot);
        });
    }
    //------
    //controllo fine salvataggio grabs
    var fineSalvaGrab = function(fafail) {
        //se è il primo faccio pre misure
        var continuare = true;
        if (fatti == 0) {
            if (primopasso) {
                setTimeout( leggiMisurePrimoFrame, 1000); //poi torna a finesalvagrab
                continuare = false;
            }
        }
        primopasso = false;
        
        //se si continua
        if (continuare) {
            setTimeout( function() {
                fineSalvaGrab_continua(fafail);
            }, 500)
        }
        //--
    }
    //------
    var fineSalvaGrab_continua = function(fafail) {
        fatti++;
        eventProgress(1,fatti/daFarne,fatti, fafail);
        writeExifData(contaSS);

        if (!flyscannerPublic.stopped) {
            if (fatti >= daFarne) {
                //FINITO
                finitoTutto();  
            }
            else { 
                //continua il ciclo
                contaSS++;
                salvaGrab();
            }
        } else { 
            //stoppato
            flyscannerPublic.stopped = false;
            message('3> *** STOPPED!!!***');
            eventProgress(0, false);
            //pulisco
            if (cancellaGrab) cancellaCartella(cartellaGrab, true); //cancello files in grabs e eventualmente tutta la cartella
        }
    }
    //------
    //normalizza porzione -n di file output
    var normalizza = function(danormare, totata) {
        var normata = String(danormare);
        if (outFile_numeroEsteso) {
            var totuzz = (String(totata)).length;
            var rimast =  totuzz - normata.length;
            for (var carca = 0; carca < rimast; carca++){
               normata = "0" + normata;
            }
        }
        return normata;
    }
    //---------------------------
    //FUNZIONI LETTURA DATI
    //LEGGI EXIF CAMPIONE procedura
    //copia i dati exif dal campione ai grab
    var leggiDatiCampione = function() {
        message('2> LOADED JPG BASE EXIF'); 

        //PRENDO DATI CAMPIONE
        exifCampione = readExifData( pathCampioneFile, false );
        
        //PREPARO CARTELLA OUTPUT
        if (cancellaOut) cancellaCartella(cartellaOutput, false); //cancello files in output
    }
    //PRE-MISURA procedura -> lancia ruttorno grab asincrono
    //lege le misure dal primo grab salvato
    var leggiMisurePrimoFrame = function() {
        //message('3> MISURING...'); 
        message("3>   ["+(contaSS+1)+"] first frame ckeck: ok"); 
                
        //PRENDO LE MISURE DI UNO DEI GRAB
        //imagesize
        pixelXDim = 4096;
        pixelYDim = 2160;
        var ret_data = imagesize( grabbi[0] );
        if (ret_data.width != undefined) pixelXDim = ret_data.width;
        if (ret_data.height != undefined) pixelYDim = ret_data.height;

        //ritorna
        fineSalvaGrab(); 
    }  
    //---------------------------
    //FUNZIONI EXIF
    //legge gli exif e  opzionalmente li salva in un file
    var readExifData = function(patto, scriv) {
            var verboso = false;
            var scrivifile = true;
            var rimuovithumbnail = true;
            if (scriv === false ) scrivifile = false;

            var jpeg0 = fs.readFileSync(patto);
            var data0 = jpeg0.toString("binary");
            var exifObj = piexif.load(data0);
            
            if (scrivifile) {
                if (verboso) message('\n> DATI '+patto+' --------');

                var filetxt = "";
                for (var ifd in exifObj) {
                    if (ifd == "thumbnail") {
                        continue;
                    }
                    if (verboso) message("   -" + ifd);
                    filetxt+="- " + ifd+"\n";
                    for (var tag in exifObj[ifd]) {
                        if (verboso) message("      " + piexif.TAGS[ifd][tag]["name"] + ":" + exifObj[ifd][tag]);
                        filetxt+= "     " + piexif.TAGS[ifd][tag]["name"] + ":" + exifObj[ifd][tag]+"\n";
                    }
                }
                fs.writeFile(patto+'_exif.txt',filetxt , function (err) {
                    if (err) return message(err);
                    message('*   Exif di '+patto+' salvati');
                });
                if (verboso) message('> ----------------------\n');
                filetxt = null;

            } else  {

            }
            jpeg0 = null;
            data0 = null;
            //exifObj = null;
        
            if (rimuovithumbnail) exifObj["thumbnail"] = null;
            return exifObj;
        }
    //scrive l'exif per l'id
    var writeExifData = function(idd) {
            var filename1 =  grabbi[idd];
            var filename2 = outti[idd];  
            //leggo grab
            var jpeg = fs.readFileSync(filename1);
            var data = jpeg.toString("binary");

            //MODIFICO
            var oggettoSrt = parse_dji( datti[idd].text);
            //message( '>Time: '+ srtdata[idd].startTime+'\n>'+ JSON.stringify(parse_dji(srtdata[idd].text)) );

            var exifObj = exifCampione;//piexif.load(data);

            exifObj["GPS"][piexif.GPSIFD.GPSDateStamp] = oggettoSrt.dateTime; //ok
            exifObj["GPS"][piexif.GPSIFD.GPSLatitude] = oggettoSrt.gpsLat; //ok
            exifObj["GPS"][piexif.GPSIFD.GPSLongitude] = oggettoSrt.gpsLon; //ok
            exifObj["GPS"][piexif.GPSIFD.GPSAltitude] = oggettoSrt.altitude; //ok

            exifObj["0th"][piexif.ImageIFD.Software] = APP_NAME+' '+APP_VERSION; //ok
            exifObj["0th"][piexif.ImageIFD.DateTime] = oggettoSrt.dateTime; //ok?
            exifObj["0th"][piexif.ImageIFD.ImageDescription] = filename2; //ok

            exifObj["Exif"][piexif.ExifIFD.MakerNote] = "DJI + ATLANTIDE DESIGN"; //ok
            exifObj["Exif"][piexif.ExifIFD.LensMake] = "DJI"; //ok
            exifObj["Exif"][piexif.ExifIFD.ISOSpeedRatings] = parseInt(oggettoSrt.ISO); //ok
            exifObj["Exif"][piexif.ExifIFD.DateTimeOriginal] = oggettoSrt.dateTime; //ok
            exifObj["Exif"][piexif.ExifIFD.DateTimeDigitized] = oggettoSrt.dateTime; //ok
            exifObj["Exif"][piexif.ExifIFD.FNumber] = oggettoSrt.Fnum; //ok
            exifObj["Exif"][piexif.ExifIFD.PixelXDimension] = pixelXDim; //4096x2160 
            exifObj["Exif"][piexif.ExifIFD.PixelYDimension] = pixelYDim; //4000x2250
            exifObj["Exif"][piexif.ExifIFD.ExposureTime] = oggettoSrt.Shutter; 
            exifObj["Exif"][piexif.ExifIFD.ExposureBiasValue] = oggettoSrt.EV;

            //salvo output
            var exifbytes = piexif.dump(exifObj);
            var newData = piexif.insert(exifbytes, data);
            var newJpeg = new Buffer(newData, "binary");
            fs.writeFileSync(filename2, newJpeg);

            eventProgress(3,(idd+1)/daFarne,(idd+1), filename2);
            message("3>   ["+(idd+1)+"] saving: "+filename2 );
    }
     //---------------------------
    //FINE TUTTO procedura
    //tutto finito
    var finitoTutto = function() {
        //ciclo asincrono
        message('3> SAVED '+daFarne+' '+nomeFrami);
        message( '---');
        message('4> ALL DONE !');    
        eventProgress(0, true);
        
        //pulisco
        if (cancellaGrab) cancellaCartella(cartellaGrab, true); //cancello files in grabs e eventualmente tutta la cartella
    }
    //---------------------------
    //FUNZIONI UTILITY
    //cancella contenuto cartella
    var cancellaCartella = function(dirPath, removeSelf) {
          if (removeSelf === undefined)
            removeSelf = false;
          try { var files = fs.readdirSync(dirPath); }
          catch(e) { return; }
          if (files.length > 0)
            for (var i = 0; i < files.length; i++) {
              var filePath = dirPath + '/' + files[i];
              if (fs.statSync(filePath).isFile())
                fs.unlinkSync(filePath);
              else
                fs.rmdirSync(filePath);
            }
          if (removeSelf)
            fs.rmdirSync(dirPath);
        };
    //log text
    var message = function(str) { 
       if (flyscannerPublic.verbose) genitore.message(str); 
    }
    //progress event
    var eventProgress = function(ev_tipo, ev_perc, ev_num, ev_file) { 
        if (ev_perc < 0) ev_perc = 0;
        if (ev_perc > 1) ev_perc = 1;
       genitore.eventProgress(ev_tipo, ev_perc, ev_num, ev_file); 
    }
    //---------------------------
    //FINE FLYSCAN    
    
     return flyscannerPublic;
})();

// ignore exports for browser
if (typeof exports === 'object') {
    module.exports = flyscanner;
}
